
/*
 * SPDX-FileCopyrightText: Copyright (c) 2023 Carl Zeiss Meditec AG
 *
 * SPDX-License-Identifier: Apache-2.0
 */

#ifndef ZEPHYR_DRIVERS_SENSOR_ADLTC2991_REG_H
#define ZEPHYR_DRIVERS_SENSOR_ADLTC2991_REG_H

/* Register addresses for ltc2991 */
#define ADLTC2991_REG_STATUS             0x00U
#define ADLTC2991_REG_TRIGGER            0x01U
#define ADLTC2991_REG_CONTROL_V1234      0x06U
#define ADLTC2991_REG_CONTROL_V5678      0x07U
#define ADLTC2991_REG_PWM_THRESHOLD_LSB  0x08U
#define ADLTC2991_REG_PWM_THRESHOLD_MSB  0x09U
#define ADLTC2991_REG_V1_MSB             0x0AU
#define ADLTC2991_REG_V1_LSB             0x0BU
#define ADLTC2991_REG_V2_MSB             0x0CU
#define ADLTC2991_REG_V2_LSB             0x0DU
#define ADLTC2991_REG_V3_MSB             0x0EU
#define ADLTC2991_REG_V3_LSB             0x0FU
#define ADLTC2991_REG_V4_MSB             0x10U
#define ADLTC2991_REG_V4_LSB             0x11U
#define ADLTC2991_REG_V5_MSB             0x12U
#define ADLTC2991_REG_V5_LSB             0x13U
#define ADLTC2991_REG_V6_MSB             0x14U
#define ADLTC2991_REG_V6_LSB             0x15U
#define ADLTC2991_REG_V7_MSB             0x16U
#define ADLTC2991_REG_V7_LSB             0x17U
#define ADLTC2991_REG_V8_MSB             0x18U
#define ADLTC2991_REG_V8_LSB             0x19U
#define ADLTC2991_REG_INTERNAL_TEMP_MSB  0x1AU
#define ADLTC2991_REG_INTERNAL_TEMP_LSB  0x1BU
#define ADLTC2991_REG_VCC_MSB            0x1CU
#define ADLTC2991_REG_VCC_LSB            0x1DU

// following reg addresses actually for ltc2990
// #define ADLTC2991_REG_STATUS            0x00U
// #define ADLTC2991_REG_CONTROL           0x01U
//  #define ADLTC2991_REG_TRIGGER           0x02U
// #define ADLTC2991_REG_UNUSED            0x03U
//  #define ADLTC2991_REG_INTERNAL_TEMP_MSB 0x04U
//  #define ADLTC2991_REG_INTERNAL_TEMP_LSB 0x05U
// #define ADLTC2991_REG_V1_MSB            0x06U
// #define ADLTC2991_REG_V1_LSB            0x07U
// #define ADLTC2991_REG_V2_MSB            0x08U
// #define ADLTC2991_REG_V2_LSB            0x09U
// #define ADLTC2991_REG_V3_MSB            0x0AU
// #define ADLTC2991_REG_V3_LSB            0x0BU
// #define ADLTC2991_REG_V4_MSB            0x0CU
// #define ADLTC2991_REG_V4_LSB            0x0DU
// #define ADLTC2991_REG_VCC_MSB           0x0EU
// #define ADLTC2991_REG_VCC_LSB           0x0FU

#define ADLTC2991_VOLTAGE_SINGLE_ENDED_VALUES 2U
#define ADLTC2991_VOLTAGE_DIFF_VALUES         1U
#define ADLTC2991_TEMP_VALUES                 1U
#define ADLTC2991_CURRENT_VALUES              1U
#define ADLTC2991_MICROOHM_CONVERSION_FACTOR  1000000U

// #define ADLTC2991_MODE_V1_V2_TR2               0U
// #define ADLTC2991_MODE_V1_MINUS_V2_TR2         1U
// #define ADLTC2991_MODE_V1_MINUS_V2_V3_V4       2U
// #define ADLTC2991_MODE_TR1_V3_V4               3U
// #define ADLTC2991_MODE_TR1_V3_MINUS_V4         4U
// #define ADLTC2991_MODE_TR1_TR2                 5U
// #define ADLTC2991_MODE_V1_MINUS_V2_V3_MINUS_V4 6U
// #define ADLTC2991_MODE_V1_V2_V3_V4             7U

// #define ADLTC2991_MEASURE_INTERNAL_TEMPERATURE_ONLY 0U
// #define ADLTC2991_MEASURE_PINS_V1_V2_ONLY           1U
// #define ADLTC2991_MEASURE_PINS_V3_V4_ONLY           2U
// #define ADLTC2991_MEASURE_ALL_PINS_PER_MODE_2_0     3U

#define ADLTC2991_VOLTAGE_SINGLEENDED_CONVERSION_FACTOR 30518
#define ADLTC2991_VOLTAGE_DIFFERENTIAL_CONVERSION_FACTOR 1942
#define ADLTC2991_TEMPERATURE_CONVERSION_FACTOR 62500

#define ADLTC2991_MODE_2_0_MAX_VALUE 7U
#define ADLTC2991_MODE_4_3_MAX_VALUE 3U

#endif /* ZEPHYR_DRIVERS_SENSOR_ADLTC2991_REG_H */